Coin: SoShadowDirectionalLight Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoShadowDirectionalLight Class Reference

The SoShadowDirectionalLight class is a node for setting up a directional light which casts shadows. More...

`#include <Inventor/annex/FXViz/nodes/SoShadowDirectionalLight.h>`

Inheritance diagram for SoShadowDirectionalLight:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoShadowDirectionalLight (void)
virtual void | GLRender (SoGLRenderAction *action)
Public Member Functions inherited from SoDirectionalLight
| SoDirectionalLight (void)
Public Member Functions inherited from SoLight
virtual void | callback (SoCallbackAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDirectionalLight
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoLight
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFNode | shadowMapScene
SoSFFloat | maxShadowDistance
SoSFVec3f | bboxCenter
SoSFVec3f | bboxSize
Public Attributes inherited from SoDirectionalLight
SoSFVec3f | direction
Public Attributes inherited from SoLight
SoSFBool | on
SoSFFloat | intensity
SoSFColor | color

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoShadowDirectionalLight ()
Protected Member Functions inherited from SoDirectionalLight
virtual | ~SoDirectionalLight ()
Protected Member Functions inherited from SoLight
| SoLight (void)
virtual | ~SoLight ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoDirectionalLight
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoLight
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoShadowDirectionalLight class is a node for setting up a directional light which casts shadows.

Directional lights usually affect everything, but since it is not always feasible to use one shadow map for the entire scene graph. This node has some extra features to work around this.

It calculates the intersection between the current view volume and either the scene bounding box, or the bounding box provided in this node. The shadows are only calculated for this volume. This means that you'll get more detailed shadows as you zoom in on items in the scene graph.

In addition, you can set the maximum distance from the camera which will be shaded with shadows. Think of this a new far plane for the camera which only affects shadows.

As with SoShadowSpotLight, it's possible to optimize further by setting your own shadow caster scene graph in the shadowMapScene field.

The example scene graph below demonstrates how you can use this node to create shadows on a large number of objects, and still get decent precision when zooming in. To further reduce the volume covered by the shadow map, you can set maxShadowDistance to some number > 0. This is the distance from the camera where shadows will be visible.

DirectionalLight {
direction 0 0 -1
intensity 0.2
}
ShadowGroup {
quality 1 # to get per pixel lighting
precision 1
ShadowDirectionalLight {
direction 1 1 -1
intensity 0.8
# enable this to reduce the shadow view distance
# maxShadowDistance 200
}
# 900 cubes spaced out over a fairly large area
Array {
origin CENTER
numElements1 30
numElements2 30
numElements3 1
separation1 20 0 0
separation2 0 20 0
separation3 0 0 0
Material { diffuseColor 1 0 0 specularColor 1 1 1 }
Cube { width 4 height 4 depth 4 }
}
# a chess board
Coordinate3 { point [ -400 -400 -3, 400 -400 -3, 400 400 -3, -400 400 -3 ] }
Material { specularColor 1 1 1 shininess 0.9 }
Complexity { textureQuality 0.1 }
Texture2 { image 2 2 3 0xffffff 0x225588 0x225588 0xffffff }
Texture2Transform { scaleFactor 20 20 }
FaceSet { numVertices 4 }
}
SoDirectionalLight::direction
SoSFVec3f direction
Definition SoDirectionalLight.h:49
SoFieldContainer::get
void get(SbString &fielddata)
Definition SoFieldContainer.cpp:396
SoLight::intensity
SoSFFloat intensity
Definition SoLight.h:50

Since
  Coin 3.0

## Constructor & Destructor Documentation

## ◆ SoShadowDirectionalLight()

SoShadowDirectionalLight::SoShadowDirectionalLight | ( | void |  | ) |

Constructor.

## ◆ ~SoShadowDirectionalLight()

SoShadowDirectionalLight::~SoShadowDirectionalLight | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoShadowDirectionalLight::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoShadowDirectionalLight::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoDirectionalLight.

## ◆ getFieldDataPtr()

const SoFieldData ** SoShadowDirectionalLight::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoShadowDirectionalLight::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoDirectionalLight.

## ◆ initClass()

void SoShadowDirectionalLight::initClass | ( | void |  | ) |
| static

## ◆ GLRender()

void SoShadowDirectionalLight::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoDirectionalLight.

## Member Data Documentation

## ◆ shadowMapScene

SoSFNode SoShadowDirectionalLight::shadowMapScene

The shadow map scene graph. If this is NULL (the default), the node will behave as a normal SoDirectionalLight node.

## ◆ maxShadowDistance

SoSFFloat SoShadowDirectionalLight::maxShadowDistance

The maximum distance (from the camera) that we'll see shadows from this light source.

## ◆ bboxCenter

SoSFVec3f SoShadowDirectionalLight::bboxCenter

Can be used to specify the volume that should be used for calculating the resulting shadow volume.

## ◆ bboxSize

SoSFVec3f SoShadowDirectionalLight::bboxSize

Can be used to specify the volume that should be used for calculating the resulting shadow volume.

The documentation for this class was generated from the following files:

- SoShadowDirectionalLight.h
- SoShadowDirectionalLight.cpp